from math import sqrt
size(640, 480)
class Planet:
	def __init__(self, X=0.0, Y=0.0, XVec=0.0, YVec=0.0, Mass=0.0, Radius=0.0, Col=color(0)):
		self.X = X
		self.Y = Y
		self.XVec = XVec
		self.YVec = YVec
		self.Mass = Mass
		self.Radius = Radius
		self.Col = Col
	def draw(self):
		fill(self.Col)
		oval(self.X-self.Radius, self.Y-self.Radius, self.Radius*2, self.Radius*2)
		fill(0.5)
		text("Mass = %i" % self.Mass, self.X, self.Y)

speed(30)
colormode(HSB)
Body = [Planet(random(WIDTH/-2, WIDTH/2),
               random(HEIGHT/-2, HEIGHT/2),
               random(0.5, -0.5),
               random(0.5, -0.5),
               random(50),
               random(50),
               color(float(i)/4.0, 1, 1))
        for i in range(4)]

Body += [Planet(0, 0, 0.0, 0.0, 30, 30, color(1))]
def draw():
	fontsize(12)
	colormode(HSB)
	translate(WIDTH/2, HEIGHT/2)
	background(0)
	for i in range(len(Body)):

		if (Body[i].Col.saturation == 0.0) and (Body[i].Col.brightness == 1.0):
			Body[i].XVec = ((MOUSEX-(WIDTH/2))-Body[i].X)/5
			Body[i].YVec = ((MOUSEY-(HEIGHT/2))-Body[i].Y)/5
			if keydown:
				if keycode == 45: Body[i].Mass -= 1
				if keycode == 46: Body[i].Mass += 1
				if keycode == 14: Body[i].Radius -= 1
				if keycode == 15: Body[i].Radius += 1

		for j in range (i+1,len(Body)):
			Dist_X = Body[i].X - Body[j].X
			Dist_Y = Body[i].Y - Body[j].Y
			Dist_squared = Dist_X**2 + Dist_Y**2
			Dist = sqrt(Dist_squared)

			Force = Body[j].Mass/Dist_squared
			Body[i].XVec -= (Dist_X/Dist)*Force
			Body[i].YVec -= (Dist_Y/Dist)*Force
			Body[i].X += Body[i].XVec
			Body[i].Y += Body[i].YVec

			Force = Body[i].Mass/Dist_squared
			Body[j].XVec += (Dist_X/Dist)*Force
			Body[j].YVec += (Dist_Y/Dist)*Force
			Body[j].X += Body[j].XVec
			Body[j].Y += Body[j].YVec
			
		if (Body[i].X > WIDTH/2) or (Body[i].X < WIDTH/-2): Body[i].XVec *= -1
		if (Body[i].Y > HEIGHT/2) or (Body[i].Y < HEIGHT/-2): Body[i].YVec *= -1

		Body[i].draw()
	reset()
